% TeX.lhs
%
% This file is part of CalcCheck
%
% Copyright (c) 2011  Wolfram Kahl
% All rights reserved
%
\section{|TeX|: Representation of Raw {TeX{}} Source}

\begin{code}
module TeX where
\end{code}

We do not go into catcode changes,
so |TChar| cannot contain a backslash.

\begin{code}
data TeX
  = TChar Char
  | TMacro String
  | TGroup [TeX]
  | TMath String String [TeX]
\end{code}

\begin{code}
showsTeX :: TeX -> ShowS
showsTeX (TChar c) = (c:)
showsTeX (TMacro s) = ('\\' :) . (s ++)
showsTeX (TGroup ts) = ('{' :) . showsTeXs ts . ('}' :) 
showsTeX (TMath open close ts) = (open ++) . showsTeXs ts . (close ++)

showsTeXs :: [TeX] -> ShowS
showsTeXs = flip (foldr showsTeX)

instance Show TeX where
  showsPrec _ = showsTeX
  showList = showsTeXs
\end{code}

\begin{code}

\end{code}

%{{{ EMACS lv
% Local Variables:
% folded-file: t
% fold-internal-margins: 0
% eval: (fold-set-marks "%{{{ " "%}}}")
% eval: (fold-whole-buffer)
% end:
%}}}
